//-----------------------------------------------------------------------------
#ifndef CaptureThreadH
#define CaptureThreadH CaptureThreadH
//-----------------------------------------------------------------------------
#include <mvIMPACT_CPP/mvIMPACT_acquire.h>
#include <wx/thread.h>
#include <wx/string.h>

class wxEvtHandler;
class wxWindow;
struct RequestInfoData;

//------------------------------------------------------------------------------
class CaptureThread : public wxThread
//------------------------------------------------------------------------------
{
	static unsigned int						m_activeInstance;
	volatile bool							m_boLive;
	volatile bool							m_boRecord;
	mutable wxCriticalSection				m_critSect;
	mutable int								m_currentRequest;
	int										m_discardedImages;
	static unsigned int						m_instanceCnt;
	unsigned int							m_instanceNr;
	wxString								m_lastErrorMessage;
	wxString								m_lastRequestResult;
	mutable int								m_nextPendingRequest;
	int										m_parentWindowID;
	mvIMPACT::acquire::Device*				m_pDev;
	mvIMPACT::acquire::FunctionInterface*	m_pFuncInterface;
	mvIMPACT::acquire::ImageRequestControl*	m_pImageRequestControl;
	wxEvtHandler*							m_pParentWindowEventHandler;
	std::vector<int>						m_vSequence;
	size_t									m_currentSequenceIndexToDisplay;
	size_t									m_currentCountToRecord;
	size_t									m_SkippedImageCount;
	int										RequestImages( void );
	int										ExchangeLastSnapResult( int newResult ) const;
	void									FreeSequence( void );
	void									UnlockRequest( int nr ) const;
	bool									CheckSequenceRestart( void ) const;
protected:
	void*									Entry( void );
public:
	CaptureThread( mvIMPACT::acquire::FunctionInterface* pFuncInterface, mvIMPACT::acquire::Device* pDev, wxWindow* pParentWindow );
	~CaptureThread();
	mvIMPACT::acquire::TRequestResult		GetImageData( mvIMPACT::acquire::ImageBufferDesc* pImgBufDesc, RequestInfoData* pReqInfo, wxString& pixelFormat, bool boFillInfoVector, std::vector<wxString>& infoStrings ) const;
	int										GetLastSnapResult( void ) const;
	wxString								GetLastRequestResult( void ) const;
	int										SetLiveMode( bool boOn );
	bool 									GetLiveMode( void ) const { return m_boLive;}
	int										SetRecordMode( bool boOn );
	bool 									GetRecordMode( void ) const { return m_boRecord;}
	void									SetActive( void );
	int										RequestSingle( void );
	size_t									DisplaySequenceRequest( size_t nr = 0 );
	size_t									DisplaySequenceRequestNext( void );
	size_t									DisplaySequenceRequestPrev( void );
	int										RecordSequence( void );
	const	std::vector<int>&				GetSequenceImageVector( void ) const { return m_vSequence;}
	size_t									GetSequenceImageCnt( void ) const { return m_vSequence.size();}
	size_t									GetCurrentSequenceIndex( void ) const { return m_currentSequenceIndexToDisplay;}
	size_t									GetSkippedImageCount( void ){ size_t res = m_SkippedImageCount; m_SkippedImageCount=0; return res;}
};

#endif // CaptureThreadH
