#ifndef PoCLControlH
#define PoCLControlH PoCLControlH

#ifdef linux
#include "matrix_types.h"
#include <linux/timer.h>
#endif

#include "HyperionRegister.h"

//----------------------------------------------------------------------------------------------
enum POCL_CONTROLLER_STATE 
//----------------------------------------------------------------------------------------------
{
	epcsConnectionSense = 0,
	epcsCameraCableDetect,
	epcsClockDetect
};

//----------------------------------------------------------------------------------------------
enum POCL_THRESHOLD
//----------------------------------------------------------------------------------------------
{
	eptNonPoCLCamera = 0,
	eptPoCLCamera,
	eptInternalError,
	eptNoCameraDetected
};

//----------------------------------------------------------------------------------------------
typedef struct _POCL_OBJECT
//----------------------------------------------------------------------------------------------
{
	unsigned int InitDone;
	int register_index;
	POCL_CONTROL *Base;
#ifdef linux
	struct timer_list timer;
#else
	KDPC PoCLDpc;
	KTIMER Timer;
#endif
	enum POCL_CONTROLLER_STATE Action;
	enum POCL_THRESHOLD DetectedCamera;
	unsigned char CLClockLost;
}POCL_OBJECT;

void HandlePoCLEvent( POCL_OBJECT *ppo );
int CreatePoCLObject( POCL_OBJECT *ppo, void *base, unsigned int reg_index);
void ClosePoCL( POCL_OBJECT *ppo );
unsigned char GetCLClockStatus( POCL_OBJECT *ppo );

#endif // PoCLControlH
